
// cubemap emulation with sides


void mainCubemap( out vec4 fragColor, in vec2 fragCoord, in vec3 rayOri, in vec3 rayDir, 
                in int side_size);

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    fragColor = vec4(0.);
    
    vec3 rd;vec2 fc_cube;int index;int side_size;
    buffer_cubemap_rd(fragCoord, rd, fc_cube, index, side_size, iResolution.xy);
    if(index<0)return;
    
    
    fc_cube.y = float(side_size)-fc_cube.y-0.0001;
    
    mainCubemap(fragColor, fc_cube, vec3(0.), rd, side_size);
}


// just added side_size to replace cubemap iResolution

void mainCubemap( out vec4 fragColor, in vec2 fragCoord, in vec3 rayOri, in vec3 rayDir,
              in int side_size)
{
    vec3 col=vec3(0.);
    
    vec3 Front_side_col = vec3(1.,0.,0.);
    vec3 Back_side_col = vec3(0.,1.,1.);
    vec3 Up_side_col = vec3(0.,1.,0.);
    vec3 Down_side_col = vec3(1.,0.,1.);
    vec3 Left_side_col = vec3(1.,1.,0.);
    vec3 Right_side_col = vec3(0.,0.,1.);
    
    int Front_side = 0;
    int Back_side = 1;
    int Up_side = 2;
    int Down_side = 3;
    int Left_side = 4;
    int Right_side = 5;
    
    int side_idx; vec2 side_uv;
    convert_xyz_to_cube_uv(rayDir, side_idx, side_uv);
    vec3 side_col = vec3(0.);
    
    if(Front_side == side_idx)side_col = Front_side_col;else
    if(Back_side == side_idx)side_col = Back_side_col;else
    if(Up_side == side_idx)side_col = Up_side_col;else
    if(Down_side == side_idx)side_col = Down_side_col;else
    if(Right_side == side_idx)side_col = Right_side_col;else
    if(Left_side == side_idx)side_col = Left_side_col;
    
    
    vec2 side_resolution=vec2(float(side_size)); // cube side resolution
    
    vec2 tuv=fragCoord/side_resolution-0.5;
    tuv.y=-tuv.y;
    side_uv+=-0.5;
    
    // grid with cube uv from cube fragCoord
    col = grid(tuv, 0.005, side_idx, side_col).rgb;
    
    // grid with cube uv from rd
    //col = grid(side_uv, 0.005, side_idx, side_col).rgb;
    
    // square borders
    //col=mix(col, side_col, 1.-step(abs(tuv.x),0.45)*step(abs(tuv.y),0.45));
    
    // lines 
    /*
    float d = dist_vertical_line(rayDir);
    col= mix(vec3(0.,1.,1.), col, smoothstep(0.01,0.015,d));
    d = dist_horizontal_line(rayDir);
    col= mix(vec3(1.,1.,0.), col, smoothstep(0.01,0.015,d));
    //*/
    
    fragColor = vec4(col,1.0);
}
