// Created by Danil (2021+) https://twitter.com/AruGL

// The MIT License

// self https://www.shadertoy.com/view/NttGWr


// 0-display CubeA, 1-display BufA cubemap emulation, 2-display BufB panorama
// 3-display bufA and bufB in screen UV as 2d texture

#define USE_METHOD 0


//Cubemap order follow https://en.wikipedia.org/wiki/Cube_mapping
//  Front_side = 0
//  Back_side = 1
//  Up_side = 2
//  Down_side = 3
//  Left_side = 4
//  Right_side = 5

vec3 cam(vec2 uv, vec2 ires, vec2 mouse);
vec2 rd_to_screen_uv(vec3 rd, vec2 ires, vec2 mouse);

#define CubeMap iCubemap

#if USE_METHOD==0
void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    fragColor = vec4(0.);
    vec2 uv = fragCoord/iResolution.xy * 2.0 - 1.0;
    uv.y *= iResolution.y/iResolution.x;
    vec3 rd = cam(uv, iResolution.xy, iMouse.xy);
    fragColor = texture_buffer_cubemap(CubeMap, rd);
    
    uv = fragCoord.xy/iResolution.xy-0.5;
    uv*= 2.5;uv+=2./2.75;
    if(abs(uv.x)<.5 && abs(uv.y)<.5){
        rd = getCubeMap(uv+0.5);
        fragColor = texture_buffer_cubemap(CubeMap, rd);
        vec2 tuv = rd_to_screen_uv(rd, iResolution.xy, iMouse.xy);
        if((abs(tuv.x-0.5)<0.5)&&(abs(tuv.y-0.5)<0.5))fragColor.r+=0.65;
    }
    
}
#elif USE_METHOD==1

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    fragColor = vec4(0.);
    vec2 uv = fragCoord/iResolution.xy * 2.0 - 1.0;
    uv.y *= iResolution.y/iResolution.x;
    vec3 rd = cam(uv, iResolution.xy, iMouse.xy);
    fragColor = texture_buffer_cubemap(iChannel0, rd);
    
    uv = fragCoord.xy/iResolution.xy-0.5;
    uv*= 2.5;uv+=2./2.75;
    if(abs(uv.x)<.5 && abs(uv.y)<.5){
        fragColor = texture_buffer_cubemap(iChannel0, getCubeMap(uv+0.5));
        //fragColor = textureLod(iChannel0, fract(uv+0.5), 0.);
    }
    //uv+=-2.*2./2.75;
    //if(abs(uv.x)<.5 && abs(uv.y)<.5)fragColor = textureLod(CubeMap, getCubeMap(uv+0.5),0.);
    
}

#elif USE_METHOD==2

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    fragColor = vec4(0.);
    vec2 uv = fragCoord/iResolution.xy * 2.0 - 1.0;
    uv.y *= iResolution.y/iResolution.x;
    vec3 rd = cam(uv, iResolution.xy, iMouse.xy);
    vec3 rd_pan=rd*roty(3.1415926/2.);
    
    vec2 pan_uv;
    panorama_rd_to_pan_uv(rd_pan, pan_uv);

    fragColor = textureLod(iChannel1, pan_uv, 0.);
    
    
    uv = fragCoord.xy/iResolution.xy-0.5;
    uv*= 2.5;uv+=2./2.75;
    if(abs(uv.x)<.5 && abs(uv.y)<.5){
        uv=(uv+0.5);
        vec3 trd = getCubeMap(uv)*roty(3.1415926/2.);
        vec2 tpan_uv;
        panorama_rd_to_pan_uv(trd, tpan_uv);
        fragColor = textureLod(iChannel1, tpan_uv, 0.);
        //fragColor = textureLod(iChannel1, fract(uv), 0.);
    }
    //uv+=-2.*2./2.75;
    //if(abs(uv.x)<.5 && abs(uv.y)<.5)fragColor = textureLod(CubeMap, getCubeMap(uv+0.5),0.);
    
}

#elif USE_METHOD==3
void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    fragColor = vec4(0.);
    vec2 uv = fragCoord.xy/iResolution.xy;
    uv*=2.;
    if(uv.x<1.&&uv.y>1.)
    fragColor = texture_buffer_cubemap(CubeMap, getCubeMap(fract(uv)));
    else if(uv.x<1.&&uv.y<1.)
    fragColor = textureLod(iChannel0, fract(uv), 0.);
    else if(uv.y<1.)
    fragColor = textureLod(iChannel1, fract(uv), 0.);
    
}

#endif

// rd to screen UV, UV in 0-1 range
vec2 rd_to_screen_uv(vec3 rd, vec2 ires, vec2 mouse)
{
    vec2 res = (ires.xy / ires.y);
    vec2 im = (mouse.xy) / ires.y - res/2.0;
    im*=3.14159263*1.15;
    im.y = -im.y;
    
    rd=rd*(roty(-im.x) * rotx(im.y));
    
    if(rd.z<0.0001)return vec2(0.0);
    
    float fov = 70.;
    float aspect = ires.x / ires.y;
    float screenSize = (1.0 / (tan(((180.-fov)* (3.14159263 / 180.0)) / 2.0)));
    
    vec2 uv = rd.xy/rd.z;
    uv = uv/vec2(screenSize*aspect,screenSize);
    uv*=0.5;
    uv+=0.5;
    return uv;
}

vec3 cam(vec2 uv, vec2 ires, vec2 mouse)
{
    vec2 res = (ires.xy / ires.y);
    vec2 im = (mouse.xy) / ires.y - res/2.0;
    im*=3.14159263*1.15;
    im.y = -im.y;
    
    float fov = 70.;
    float aspect = ires.x / ires.y;
    float screenSize = (1.0 / (tan(((180.-fov)* (3.14159263 / 180.0)) / 2.0)));
    vec3 rd = normalize(vec3(uv*screenSize, 1./aspect));
    rd = (roty(-im.x) * rotx(im.y)) * rd;
    return rd;
}




